#include <stdio.h>
#include <stdlib.h>

typedef struct _tacka{
	int x;
	int y;
}tacka;

void greska(){
	printf("-1");
	exit(EXIT_FAILURE);
}

int poredi(const void *a, const void *b){
	tacka ta = *((tacka*)a);
	tacka tb = *((tacka*)b);
	return ta.x * ta.x + ta.y * ta.y - tb.x * tb.x - tb.y * tb.y;
}

int main(){
	FILE *f = fopen("tacke.txt", "r");
	if(f == NULL)
		greska();
	
	tacka *niz = malloc(2 * sizeof(tacka));
	if(niz == NULL)
		greska();
	int n = 0; //broj elemenata
	int alocirano = 2;
	
	int tx, ty;
	while(fscanf(f, "%d%d", &tx, &ty) == 2){
		//ako je uspeo da ucita tacku
		//broj elemenata niza se povecava za 1
		n++;
		if(n > alocirano){
			alocirano *= 2;
			niz = realloc(niz, alocirano * sizeof(tacka));
			if(niz == NULL)
				greska();
		}
		niz[n - 1].x = tx;
		niz[n - 1].y = ty;
	}
	
	fclose(f);
	int i;
	qsort(niz, n, sizeof(tacka), poredi);
	
	for(i = 0; i < n; i++)
		printf("%d %d\n", niz[i].x, niz[i].y);
	
	free(niz);
}
